﻿using System;
using System.ComponentModel;
using System.Linq.Expressions;
using System.Threading;
using System.Windows;
using System.Windows.Input;
using System.Windows.Threading;

namespace ThreadExample.ViewModel
{
  public class ThreadExampleViewModel : INotifyPropertyChanged
  {
    public ICommand OnClick { get; set; }
    private int i;
    public string DisplayCount { get; set; }
    public event PropertyChangedEventHandler PropertyChanged;

    public ThreadExampleViewModel()
    {
      OnClick = new RelayModel(ClickMe);
      DisplayCount = "Waiting for click";
    }

    private void ClickMe(object obj)
    {
      Thread th = new Thread(MyThreadExample);
      th.Start();
    }

    private void MyThreadExample()
    {
      while (i < 10000000000000)
      {
        i++;

        Dispatcher.CurrentDispatcher.Invoke(DispatcherPriority.Background, new Action(
          () =>
          {
            DisplayCount = i.ToString();
            OnPropertyChanged(() => this.DisplayCount);
            System.Threading.Thread.Sleep(10);
          }));
      }
    }

    protected void OnPropertyChanged<T>(Expression<Func<T>> property)
    {
      if (this.PropertyChanged != null)
      {
        var mex = property.Body as MemberExpression;
        string name = mex.Member.Name;
        this.PropertyChanged(this, new PropertyChangedEventArgs(name));
      }
    }

  }
}
